
{Feedback Servo Demo}

CON
        _clkmode = xtal1 + pll16x    'Standard clock mode 
        _xinfreq = 5_000_000         '* crystal frequency = 80 MHz
        #12, CP0, CP1, CP2, CP3      'servo control pins
        #8,  FP0, FP1, FP2, FP3      'servo feedback pins
        #0, Servo0, Servo1, Servo2, Servo3  'servo names

VAR
  byte  Cog
  word  commanded, actual     'angles
  long random      
  byte  DisplayServo, currentservo 'used to display all angles
  word  rcount                'counts random positionings
  word  Cmnded[4]            
  word theservo
  byte testgain
OBJ
  pst      : "parallax serial terminal"
  FBS      : "FeedbackServo"
  
PUB main              
  pst.Start (115_200)                        'start up ser terminal
  pst.str(String("hello, world   "))         'runs in cog 1
  pst.NewLine
  waitcnt(clkfreq/10+cnt)

 ' cog := FBS.start(CP0, FP0, 0,0, 0,0, 0,0)      'specify pin numbers 
  cog := FBS.start(cp0,fp0, CP1,FP1, cp2,fp2, cp3,fp3)   'specify pin numbers   
  pst.str(string("started position cog: "))       '0,0 pin numbers says no servo
  pst.dec(cog)
  pst.newline
  waitcnt(clkfreq/2+cnt)          'allow time for it to start

  repeat theservo from 0 to 3     'constant pulse width
    FBS.width(Servo0, 1475)
    FBS.width(Servo1, 1530)
    FBS.width(Servo2, 1450)
    FBS.width(Servo3, 1550)
  repeat 200
    showangles
    pst.newline
    waitcnt(clkfreq/100+cnt)
  repeat theservo from 0 to 3    
    fbs.width(theservo, 1500)
     
  repeat theservo from 0 to 3     'full scale changes
    pst.dec(theservo)
    pst.char(" ")
    MySet(theservo, 180)          'middle position
    pst.dec(WaitSet(theservo))    'wait for it, then display where it ended
    pst.char(" ")
    Myset(theservo, 0)            'counter clockwise
    pst.dec(WaitSet(theservo))
    pst.char(" ")
    MySet(theservo, 359)         'clockwise  
     pst.dec(WaitSet(theservo))
    pst.char(" ")
    myset(theservo, 0)            'ccw again
    pst.dec(WaitSet(theservo))
    pst.newline  

  rcount := 0                                  'all four with random movements
  random := cnt                               'seed
  repeat while rcount < 100
     repeat currentservo from 0 to 3
       if fbs.checkdone(currentservo) == 0     'issue command to whichever is done
          pst.newline
          pst.dec(currentservo)               'number
          pst.str(string("  Commanded: "))
          printThree(cmnded[currentservo])
          pst.str(string("  Actual: "))
          printThree(FBS.getpos(currentservo))
          pst.str(string("  Error: "))
          pst.dec(cmnded[currentservo] - FBS.getpos(currentservo)) 
          ?random
          commanded := || random           'drop sign bit
          commanded := (commanded // 360)    'range 0..359        
          myset(currentservo,commanded)
          cmnded[currentservo] := commanded
          pst.str(string("   "))
          pst.dec(rcount++)     
  repeat                                'stop here        
  
pub MySet(servo, degrees)
     FBS.SetPos(servo,degrees)   'set position

pub WaitSet(servo)            
     repeat while FBS.CheckDone(servo) <> 0    'await completion
     waitcnt(clkfreq/100+cnt)     
     return FBS.getpos(servo)

pub showangles
    repeat displayservo from 0 to 3
      pst.str(string("  Servo"))
      pst.dec(displayservo)
      pst.char(" ")
      printThree(FBS.getpos(displayservo))
      pst.str(string("   "))

pub printThree(number)
    if number < 100
      pst.char(" ")
    if number < 10
      pst.char(" ")
    pst.dec(number)
              
                   